주요 콘텐츠로 건너뛰기

Vue와의 통합

팁

Vue의 기본 개념과 패턴에 익숙하다고 가정합니다. 복습이 필요하다면 Vue 3 문서를 참고하세요.

DHTMLX Pivot은 일반 컴포넌트로서 Vue와 통합됩니다. 완전한 작동 설정 예시는 GitHub의 Vue Pivot 데모를 참고하세요.

프로젝트 생성​

정보

시작하기 전에 Node.js를 설치하세요.

다음 명령어는 공식 Vue 프로젝트 스캐폴딩 도구를 실행합니다:

npm create vue@latest

이 명령어는 create-vue를 설치하고 실행합니다. 자세한 내용은 Vue.js 빠른 시작을 참고하세요.

프로젝트 이름을 my-vue-pivot-app으로 지정하세요.

의존성 설치​

새 프로젝트 디렉터리로 이동합니다:

cd my-vue-pivot-app

패키지 매니저로 의존성을 설치하고 개발 서버를 시작합니다:

yarn
yarn start # 또는: yarn dev
  • npm 사용 시:
npm install
npm run dev

앱은 로컬 포트(예: http://localhost:3000)에서 실행됩니다.

Pivot 생성​

프로젝트에 Pivot 패키지를 추가한 다음 Pivot을 Vue 컴포넌트로 래핑합니다.

1단계. 패키지 설치​

Pivot 평가판 패키지를 다운로드하고 README의 단계를 따르세요. Pivot 평가판 패키지는 30일간 유효합니다.

2단계. 컴포넌트 생성​

Pivot을 마운트하는 Vue 컴포넌트를 생성합니다. src/components/Pivot.vue 파일을 새로 추가하세요.

소스 파일 가져오기​

src/components/Pivot.vue를 열고 Pivot 소스 파일을 가져옵니다. 가져오기 경로는 패키지 에디션에 따라 다릅니다:

  • PRO 버전 (로컬 폴더에서 설치한 경우):
Pivot.vue
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

패키지가 압축된 에셋을 제공하는 경우 pivot.css 대신 pivot.min.css를 가져옵니다.

  • 평가판 버전:
Pivot.vue
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

이 튜토리얼에서는 Pivot 평가판을 사용합니다.

컨테이너 설정 및 Pivot 마운트​

페이지에 Pivot을 표시하려면 컨테이너 div를 추가한 다음 생성자를 사용하여 mounted 훅에서 Pivot을 초기화합니다. unmounted 훅에서 Pivot을 제거합니다.

다음 코드 스니펫은 최소한의 Pivot Vue 컴포넌트를 정의합니다:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
mounted() {
// Pivot 컴포넌트를 초기화합니다
this.table = new Pivot(this.$refs.container, {});
},

unmounted() {
this.table.destructor(); // 언마운트 시 Pivot을 제거합니다
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

스타일 추가​

Pivot을 올바르게 렌더링하려면 프로젝트의 메인 CSS 파일에 다음 스타일을 추가합니다:

style.css
/* 초기 페이지 스타일 */
html,
body,
#app { /* #app 루트 컨테이너 사용 */
height: 100%;
padding: 0;
margin: 0;
}

/* Pivot 컨테이너 스타일 */
.widget {
width: 100%;
height: 100%;
}

데이터 로드​

Pivot에 데이터를 공급하려면 데이터셋을 준비합니다. src/data.js를 생성하고 데이터와 필드 메타데이터를 내보냅니다:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 다른 데이터 항목
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 다른 필드
];

return { dataset, fields };
};

src/App.vue를 열고 데이터를 가져온 다음 data() 옵션을 통해 노출합니다. 그런 다음 값을 새 <Pivot/> 컴포넌트에 props로 전달합니다:

App.vue
<script>
import Pivot from "./components/Pivot.vue";
import { getData } from "./data";

export default {
components: { Pivot },
data() {
const { fields, dataset } = getData();
return {
fields,
dataset
};
}
};
</script>

<template>
<Pivot :fields="fields" :dataset="dataset" />
</template>

src/components/Pivot.vue를 열고 들어오는 props를 선언한 다음 Pivot 구성 객체에 적용합니다:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
props: ["fields", "dataset"],

mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
},
// 다른 구성 속성
});
},

unmounted() {
this.table.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

이제 컴포넌트를 사용할 준비가 되었습니다. 마운트 시 Pivot은 제공된 데이터로 렌더링됩니다. 구성 속성의 전체 목록은 Pivot API 문서를 참고하세요.

이벤트 처리​

Pivot에서 사용자 동작이 발생하면 구독할 수 있는 이벤트가 발생합니다. 이벤트의 전체 목록은 이벤트 개요를 참고하세요.

다음 코드 스니펫은 mounted를 open-filter 이벤트 리스너로 확장하여 사용자가 필터를 열 때 필드 ID를 로그에 기록합니다:

Pivot.vue
<script>
// ...
export default {
// ...
mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
},
// 다른 구성 속성
});

this.table.api.on("open-filter", (ev) => {
console.log("필터가 활성화된 필드 ID:", ev.id);
});
}
// ...
}
</script>

// ...

앱을 시작하면 페이지에서 Pivot이 데이터를 렌더링하는 것을 확인할 수 있습니다.

샘플 데이터와 함께 Vue 애플리케이션에 렌더링된 DHTMLX Pivot

이제 Pivot이 Vue와 통합되었습니다. 프로젝트 요구 사항에 맞게 구성을 사용자 정의하세요. 최종 예제는 GitHub의 vue-pivot-demo를 참고하세요.

주요 콘텐츠로 건너뛰기

React와의 통합

팁

React의 기본 개념과 패턴에 익숙하다고 가정합니다. 복습이 필요하다면 React 문서를 참고하세요.

DHTMLX Pivot은 일반 컴포넌트로 React와 통합됩니다. 완전한 동작 예제는 GitHub의 React Pivot 데모를 참고하세요.

프로젝트 생성​

정보

시작하기 전에 Node.js를 설치하세요. Vite는 선택 사항입니다.

my-react-pivot-app이라는 이름으로 기본 React 프로젝트(또는 Vite 기반 프로젝트)를 생성합니다.

다음 명령어로 Create React App 프로젝트를 부트스트랩합니다:

npx create-react-app my-react-pivot-app

의존성 설치​

새 프로젝트 디렉토리로 이동합니다:

cd my-react-pivot-app

패키지 매니저로 의존성을 설치하고 개발 서버를 시작합니다:

yarn
yarn start # 또는: yarn dev
  • npm 사용 시:
npm install
npm run dev

앱이 로컬 포트(예: http://localhost:3000)에서 실행됩니다.

Pivot 생성​

프로젝트에 Pivot 패키지를 추가한 후 Pivot을 React 컴포넌트로 래핑합니다.

1단계. 패키지 설치​

Pivot 평가판 패키지를 다운로드하고 README의 단계를 따르세요. Pivot 평가판 패키지는 30일간 유효합니다.

2단계. 컴포넌트 생성​

Pivot을 마운트하는 React 컴포넌트를 생성합니다. src/Pivot.jsx 파일을 새로 추가합니다.

소스 파일 가져오기​

src/Pivot.jsx를 열고 Pivot 소스 파일을 가져옵니다. 가져오기 경로는 패키지 에디션에 따라 다릅니다:

  • PRO 버전 (로컬 폴더에서 설치):
Pivot.jsx
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';

패키지에 최소화된 에셋이 포함된 경우 pivot.css 대신 pivot.min.css를 가져옵니다.

  • 평가판:
Pivot.jsx
import { Pivot } from '@dhx/trial-pivot';
import "@dhx/trial-pivot/dist/pivot.css";

이 튜토리얼에서는 Pivot 평가판을 사용합니다.

컨테이너 설정 및 Pivot 마운트​

페이지에 Pivot을 표시하려면 컨테이너 div를 생성한 후 생성자를 사용하여 useEffect hook에서 Pivot을 초기화합니다.

다음 코드 스니펫은 최소한의 Pivot React 컴포넌트를 정의합니다:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css"; // Pivot 스타일 포함

export default function PivotComponent(props) {
let container = useRef(); // Pivot용 컨테이너 ref

useEffect(() => {
// Pivot 컴포넌트 초기화
const table = new Pivot(container.current, {});

return () => {
table.destructor(); // 언마운트 시 Pivot 제거
};
}, []);

return <div ref={container} className="widget"></div>;
}

스타일 추가​

Pivot을 올바르게 렌더링하려면 프로젝트의 메인 CSS 파일에 다음 스타일을 추가합니다:

index.css
/* 초기 페이지 스타일 */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* Pivot 컨테이너 스타일 */
.widget {
height: 100%;
width: 100%;
}

데이터 로드​

Pivot에 데이터를 공급하려면 데이터셋을 준비합니다. src/data.js를 생성하고 데이터와 필드 메타데이터를 내보냅니다:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 다른 데이터 항목
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 다른 필드
];

return { dataset, fields };
};

src/App.js를 열고 데이터를 가져온 후 <Pivot/> 컴포넌트에 props로 전달합니다:

App.js
import Pivot from "./Pivot";
import { getData } from "./data";

function App() {
const { fields, dataset } = getData();
return <Pivot fields={fields} dataset={dataset} />;
}

export default App;

src/Pivot.jsx를 열고 props를 구조 분해하여 Pivot 설정 객체에 적용합니다:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default function PivotComponent({ fields, dataset }) {
let container = useRef();

useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
},
// 다른 설정 속성
});

return () => {
table.destructor();
}
}, []);

return <div ref={container} className="widget"></div>;
}

이제 컴포넌트를 사용할 준비가 되었습니다. 마운트 시 Pivot은 제공된 데이터로 렌더링됩니다. 전체 설정 속성 목록은 Pivot API 문서를 참고하세요.

이벤트 처리​

Pivot에서 발생하는 사용자 동작은 구독할 수 있는 이벤트를 발생시킵니다. 전체 이벤트 목록은 이벤트 개요를 참고하세요.

다음 코드 스니펫은 사용자가 필터를 열 때 필드 ID를 로그에 기록하는 open-filter 이벤트 리스너를 useEffect에 추가합니다:

Pivot.jsx
// ...
useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
},
// 다른 설정 속성
});

table.api.on("open-filter", (ev) => {
console.log("필터가 활성화된 필드 id:", ev.id);
});

return () => {
table.destructor();
}
}, []);
// ...

앱을 시작하면 페이지에 Pivot이 데이터를 렌더링하는 것을 확인할 수 있습니다.

샘플 데이터와 함께 React 애플리케이션에 렌더링된 DHTMLX Pivot

이제 Pivot이 React와 통합되었습니다. 프로젝트 요구 사항에 맞게 설정을 사용자 정의하세요. 최종 예제는 GitHub의 react-pivot-demo를 참고하세요.

주요 콘텐츠로 건너뛰기

Svelte와의 통합

팁

Svelte의 기본 개념과 패턴에 익숙하다고 가정합니다. 복습이 필요하다면 Svelte 문서를 참조하세요.

DHTMLX Pivot은 일반 컴포넌트로서 Svelte와 통합됩니다. 완전한 동작 예제는 GitHub의 Svelte Pivot 데모를 참조하세요.

프로젝트 만들기​

정보

시작하기 전에 Node.js를 설치하세요. Vite는 선택 사항입니다.

다음 명령어는 Vite 프로젝트 스캐폴딩 도구를 실행하고 Svelte 템플릿을 선택할 수 있게 해줍니다:

npm create vite@latest

프로젝트 이름을 my-svelte-pivot-app으로 지정하세요.

의존성 설치​

새 프로젝트 디렉토리로 이동하세요:

cd my-svelte-pivot-app

패키지 매니저로 의존성을 설치하고 개발 서버를 시작하세요:

yarn 
yarn start # 또는: yarn dev
  • npm 사용 시:
npm install
npm run dev

앱은 로컬 포트(예: http://localhost:3000)에서 실행됩니다.

Pivot 만들기​

프로젝트에 Pivot 패키지를 추가한 다음, Svelte 컴포넌트로 Pivot을 감싸세요.

1단계. 패키지 설치​

Pivot 체험판 패키지를 다운로드하고 README의 단계를 따르세요. Pivot 체험판 패키지는 30일 동안 유효합니다.

2단계. 컴포넌트 만들기​

Pivot을 마운트하는 Svelte 컴포넌트를 만드세요. 새 파일 src/Pivot.svelte를 추가하세요.

소스 파일 가져오기​

src/Pivot.svelte를 열고 Pivot 소스 파일을 가져오세요. 가져오기 경로는 패키지 에디션에 따라 다릅니다:

  • PRO 버전 (로컬 폴더에서 설치):
Pivot.svelte
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

패키지가 최소화된 에셋을 포함하는 경우, pivot.css 대신 pivot.min.css를 가져오세요.

  • 체험판 버전:
Pivot.svelte
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

이 튜토리얼에서는 Pivot 체험판 버전을 사용합니다.

컨테이너 설정 및 Pivot 마운트​

페이지에 Pivot을 표시하려면 컨테이너 div를 추가한 다음, 생성자를 사용해 onMount 라이프사이클 훅에서 Pivot을 초기화하세요. onDestroy 훅에서 Pivot을 소멸시키세요.

다음 코드 스니펫은 최소한의 Pivot Svelte 컴포넌트를 정의합니다:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

let container; // Pivot을 위한 컨테이너 참조
let table;

onMount(() => {
// Pivot 컴포넌트 초기화
table = new Pivot(container, {});
});

onDestroy(() => {
table.destructor(); // 언마운트 시 Pivot 소멸
});
</script>

<div bind:this={container} class="widget"></div>

스타일 추가​

Pivot을 올바르게 렌더링하려면 프로젝트의 메인 CSS 파일에 다음 스타일을 추가하세요:

main.css
/* 초기 페이지 스타일 */
html,
body,
#app { /* #app 루트 컨테이너 사용 */
height: 100%;
padding: 0;
margin: 0;
}

/* Pivot 컨테이너 스타일 */
.widget {
height: 100%;
width: 100%;
}

데이터 로드​

Pivot에 데이터를 제공하려면 데이터셋을 준비하세요. src/data.js를 만들고 데이터와 필드 메타데이터를 내보내세요:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 다른 데이터 항목
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 다른 필드
];

return { dataset, fields };
};

src/App.svelte를 열고 데이터를 가져온 다음 새 <Pivot/> 컴포넌트에 props로 전달하세요:

App.svelte
<script>
import Pivot from "./Pivot.svelte";
import { getData } from "./data.js";

const { fields, dataset } = getData();
</script>

<Pivot fields={fields} dataset={dataset} />

src/Pivot.svelte를 열고 export let으로 들어오는 props를 선언하고 Pivot 설정 객체에 적용하세요:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export let fields;
export let dataset;

let container;
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
},
// 다른 설정 속성
});
});

onDestroy(() => {
table.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

이제 컴포넌트를 사용할 준비가 되었습니다. 마운트 시 Pivot은 제공된 데이터로 렌더링됩니다. 전체 설정 속성 목록은 Pivot API 문서를 참조하세요.

이벤트 처리​

Pivot에서의 사용자 동작은 구독할 수 있는 이벤트를 발생시킵니다. 전체 이벤트 목록은 이벤트 개요를 참조하세요.

다음 코드 스니펫은 사용자가 필터를 열 때 필드 ID를 기록하는 open-filter 이벤트 리스너로 onMount를 확장합니다:

Pivot.svelte
<script>
// ...
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
},
// 다른 설정 속성
});

table.api.on("open-filter", (ev) => {
console.log("필터가 활성화된 필드 id:", ev.id);
});
});

onDestroy(() => {
table.destructor();
});
</script>

// ...

앱을 시작하면 Pivot이 페이지에 데이터를 렌더링하는 것을 확인할 수 있습니다.

샘플 데이터와 함께 Svelte 애플리케이션에 렌더링된 DHTMLX Pivot

이제 Pivot이 Svelte와 통합되었습니다. 프로젝트 요구사항에 맞게 설정을 커스터마이즈하세요. 최종 예제는 GitHub의 svelte-pivot-demo를 참조하세요.

주요 콘텐츠로 건너뛰기

Angular와의 통합

팁

Angular의 기본 개념과 패턴에 익숙하다고 가정합니다. 복습이 필요하다면 Angular 문서를 참조하세요.

DHTMLX Pivot은 일반 컴포넌트로서 Angular와 통합됩니다. 완전한 동작 예제는 GitHub의 Angular Pivot 데모를 참조하세요.

프로젝트 생성​

정보

시작하기 전에 Angular CLI와 Node.js를 설치하세요.

다음 명령어로 my-angular-pivot-app이라는 새 Angular 프로젝트를 생성합니다:

ng new my-angular-pivot-app
노트

Angular CLI의 안내에 따라 서버 사이드 렌더링(SSR)과 정적 사이트 생성(SSG/Prerendering)을 비활성화하세요. 이 가이드는 클라이언트 렌더링 앱을 기준으로 합니다.

명령어를 실행하면 필요한 모든 도구가 설치됩니다. 추가 명령어는 필요하지 않습니다.

의존성 설치​

새 프로젝트 디렉토리로 이동합니다:

cd my-angular-pivot-app

yarn 패키지 매니저로 의존성을 설치하고 개발 서버를 시작합니다:

yarn
yarn start # 또는: yarn dev

앱이 로컬 포트(예: http://localhost:3000)에서 실행됩니다.

Pivot 생성​

프로젝트에 Pivot 패키지를 추가한 후, Angular 컴포넌트로 Pivot을 감쌉니다.

1단계. 패키지 설치​

Pivot 체험판 패키지를 다운로드하고 README의 단계를 따르세요. Pivot 체험판 패키지는 30일간 유효합니다.

2단계. 컴포넌트 생성​

Pivot을 마운트하는 Angular 컴포넌트를 생성합니다. src/app/ 아래에 pivot 폴더를 추가하고 src/app/pivot/pivot.component.ts를 생성합니다. 그런 다음 아래 단계를 따르세요:

소스 파일 가져오기​

src/app/pivot/pivot.component.ts를 열고 Pivot 패키지를 가져옵니다. 가져오기 경로는 패키지 버전에 따라 다릅니다:

  • PRO 버전 (로컬 폴더에서 설치):
import { Pivot } from 'dhx-pivot-package';
  • 체험판 버전:
import { Pivot } from '@dhx/trial-pivot';

이 튜토리얼은 Pivot 체험판을 사용합니다.

컨테이너 설정 및 Pivot 마운트​

페이지에 Pivot을 표시하려면 컴포넌트 템플릿에 컨테이너 요소를 정의한 후, 생성자를 사용하여 ngOnInit 훅에서 Pivot을 초기화합니다. ngOnDestroy 훅에서 Pivot을 소멸시킵니다.

다음 코드 스니펫은 최소한의 Pivot Angular 컴포넌트를 정의합니다:

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot", // "app.component.ts" 파일에서 <pivot />으로 사용되는 템플릿 이름
styleUrls: ["./pivot.component.css"], // CSS 파일 포함
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
// Pivot의 컨테이너 참조
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
// Pivot 컴포넌트 초기화
this._table = new Pivot(this.pivot_container.nativeElement, {});
}

ngOnDestroy(): void {
this._table.destructor(); // 언마운트 시 Pivot 소멸
}
}

스타일 추가​

Pivot을 올바르게 렌더링하려면 src/app/pivot/pivot.component.css를 생성하고 페이지와 Pivot 컨테이너에 대한 스타일을 작성합니다:

pivot.component.css
/* Pivot 스타일 가져오기 */
@import "@dhx/trial-pivot/dist/pivot.css";

/* 초기 페이지 스타일 */
html,
body {
margin: 0;
padding: 0;
height: 100%;
}

/* Pivot 컨테이너 스타일 */
.widget {
width: 100%;
height: 100%;
}

데이터 로드​

Pivot에 데이터를 제공하려면 데이터셋을 준비합니다. src/app/pivot/data.ts를 생성하고 데이터와 필드 메타데이터를 내보냅니다:

data.ts
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 다른 데이터 항목
];

const fields: any = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 다른 필드
];

return { dataset, fields };
};

src/app/pivot/pivot.component.ts를 열고 getData를 가져온 후 ngOnInit()에서 데이터셋을 적용합니다:

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { getData } from "./data"; // 데이터 가져오기
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot",
styleUrls: ["./pivot.component.css"],
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
const { dataset, fields } = getData(); // 데이터와 필드 메타데이터 가져오기
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
},
// 다른 구성 속성
});
}

ngOnDestroy(): void {
this._table.destructor();
}
}

이제 컴포넌트를 사용할 준비가 되었습니다. 마운트 시 Pivot은 제공된 데이터로 렌더링됩니다. 구성 속성의 전체 목록은 Pivot API 문서를 참조하세요.

이벤트 처리​

Pivot에서의 사용자 동작은 구독할 수 있는 이벤트를 발생시킵니다. 이벤트의 전체 목록은 이벤트 개요를 참조하세요.

다음 코드 스니펫은 사용자가 필터를 열 때 필드 ID를 로그에 출력하는 open-filter 이벤트 리스너를 ngOnInit에 추가합니다:

pivot.component.ts
// ...
ngOnInit() {
const { dataset, fields } = getData();
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 다른 값
]
}
});

this._table.api.on("open-filter", (ev) => {
console.log("The field id for which the filter is activated:", ev.id);
});
}

ngOnDestroy(): void {
this._table.destructor();
}

3단계. 앱에 Pivot 추가​

PivotComponent를 앱에 포함하려면 src/app/app.component.ts를 열고 기본 코드를 다음으로 교체합니다:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<pivot/>` // "pivot.component.ts" 파일에서 생성된 템플릿
})
export class AppComponent {
name = "";
}

그런 다음 src/app/app.module.ts를 생성하고 PivotComponent를 등록합니다:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { PivotComponent } from "./pivot/pivot.component";

@NgModule({
declarations: [AppComponent, PivotComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

마지막으로, src/main.ts를 열고 내용을 다음 부트스트랩 코드로 교체합니다:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

앱을 시작하면 Pivot이 페이지에 데이터를 렌더링하는 것을 확인할 수 있습니다.

샘플 데이터와 함께 Angular 애플리케��이션에 렌더링된 DHTMLX Pivot

이제 Pivot이 Angular와 통합되었습니다. 프로젝트 요구 사항에 맞게 구성을 커스터마이즈하세요. 최종 예제는 GitHub의 angular-pivot-demo를 참조하세요.